#include <ftl/operators/mask.hpp>
#include "mask_cuda.hpp"

using ftl::operators::DiscontinuityMask;
using ftl::codecs::Channel;
using ftl::rgbd::Format;

DiscontinuityMask::DiscontinuityMask(ftl::Configurable *cfg) : ftl::operators::Operator(cfg) {

}

DiscontinuityMask::~DiscontinuityMask() {

}

bool DiscontinuityMask::apply(ftl::rgbd::Frame &in, ftl::rgbd::Frame &out, ftl::rgbd::Source *s, cudaStream_t stream) {
	int radius = config()->value("radius", 2);

	ftl::cuda::discontinuity(
		out.createTexture<int>(Channel::Mask, ftl::rgbd::Format<int>(in.get<cv::cuda::GpuMat>(Channel::Depth).size())),
		in.createTexture<float>(Channel::Depth),
		s->parameters(), radius, 0
	);

	return true;
}